Flip control set by a node

Hi, this time i work with a large model of a curtain wall and some of my windows have a bad placement.

For file weight reason, i can’t put visibility for each placement i need (the red cross and the green V).
Flip_Control

In my case i use the horizontale flip control but i have too many windows to do it manualy.
I have the ID of each element i need to flip but don’t know ho it work in Dynamo or if it’s possible.

I hope it’s clear for you.

You can take a look here:

hi, already see it but i don’t need to see witch windows is in a position or an other but need to change with dynamo it position.

Assuming it’s a standard window…

Get the element’s location, and move it 1 unit along the facing orientation, and ask if the room at that point is null. If it’s outside the building it won’t have one and therefore your window ‘looks’ outside. If it’s inside the building it will have a room and needs to be flipped (at which point try above). :slight_smile:

From IDs you can get Element and than use Flipped nodes from Clockwork to flip the right side.

Sorry i use “window” as french sense

as you can see, it’s not really windows

Thank’s for this, but when i search in Dynamo the node you talk, it gave me nothing.

In my project we use curtain wall panel for the “windows”.


Choose what suitable for you.

I use it this morning but nothing append.

Before :

Red cross signified i do it manualy

If i zoom on two bloc,we can see the problem.

I try this with dynamo but the two node doesn’t work .

I don’t know if the nodes really replace this button :

If I unterstand you correct you want to flip them to outside of building. That works with FlipFacingOrientation on Doors and Windows. But you said that you created your windows as curtain walls so you have to use “Wall Flip” Node from Clockwork. It should work.

Tried it

Doesn’t work. :confused:

I also tried the node family rotation but it doesn’t work too.

Can you please share the family? As I see it was created as Curtain Panel. We should find the Flip Method for that Class.

Finally I solved it :slight_smile:

#Copyrights by Deniz Maral
#www.linkedin.com/in/denizmaral/

import clr
clr.AddReference('RevitAPI')
from Autodesk.Revit.DB import *

clr.AddReference("RevitServices")
import RevitServices
from RevitServices.Persistence import DocumentManager
from RevitServices.Transactions import TransactionManager

def Rotate_element(item):
	try:
		item.rotate()
		return True
	except: return False

doc = DocumentManager.Instance.CurrentDBDocument
items = UnwrapElement(IN[0])

TransactionManager.Instance.EnsureInTransaction(doc)
if isinstance(IN[0], list): OUT = [Rotate_element(x) for x in items]
else: OUT = Rotate_element(items)
TransactionManager.Instance.TransactionTaskDone()

Rotate_elementss.dyn (3.9 KB)

Hi, I have a similar problem. The FlipFacingOrientation node seems to be working only for elements with the Double Vertical flip control. Do you know any other way to flip facing oreintation of a window with Single Vertical flip control?

Did you try my code? I tried with Single Vertical flip and it works.

Can you share the family file?